
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 */

#ifndef __OBJTREE_H__
#define __OBJTREE_H__

#include "cltn.h"

/* the name of this class in older versions of objpak */
#define Tree SortCltn
/* full name */
#define SortedCollection SortCltn

typedef struct objbbt {
    struct objbbt*	ulink;
    struct objbbt*	rlink;
    struct objbbt*	llink;
    int			balance;
    id			key;
} *objbbt_t;

@interface SortCltn : Cltn
{
    struct objbbt	value;
    SEL			cmpSel;
    id                  cmpBlk;
}

+ new;
+ new:(unsigned)n;
+ newDictCompare;
+ sortBlock:sortBlock;
+ sortBy:sortBlock;
+ with:(int)nArgs,...;
+ with:firstObject with:nextObject;
+ add:firstObject;
- copy;
- deepCopy;
- emptyYourself;
- freeContents;
- free;

- (unsigned) size;
- (BOOL) isEmpty;
- eachElement;

- (unsigned) hash;
- (BOOL) isEqual:aSort;

- add:anObject;
- addNTest:anObject;
- filter:anObject;
- replace:anObject;

- remove:oldObject;

- (BOOL) includesAllOf:aCol;
- (BOOL) includesAnyOf:aCol;

- addContentsTo:aCol;
- addContentsOf:aCol;
- addAll:aCol;
- removeContentsOf:aCol;
- removeContentsFrom:aCol;
- removeAll:aCol;

- asSet;
- asOrdCltn;

- detect:aBlock;
- detect:aBlock ifNone:noneBlock;
- select:testBlock;
- reject:testBlock;
- collect:transformBlock;
- (unsigned) count:aBlock;

- elementsPerform:(SEL)aSelector;
- elementsPerform:(SEL)aSelector with:anObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject;
- elementsPerform:(SEL)aSelector with:anObject with:otherObject with:thirdObj;

- do:aBlock;
- do:aBlock until:(BOOL*)flag;

- find:anObject;
- (BOOL) contains:anObject;

- printOn:(IOD)aFile;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
@end

#endif /* __OBJTREE_H__ */

