
/*
 * Computer Algebra Kit (c) 1998 by David Stes.  All Rights Reserved.
 */

#ifndef __ca_vardns_monomial_header__
#define __ca_vardns_monomial_header__

#include "monomc.h"

typedef int *ca_vardnsmonom_t;
typedef int ca_vardnsmonom_c; /* kind of fishy */

typedef struct {
    int		nvars;
    /* could add 'order' etc in the future */
} ca_vardnsmonom_args;

#define ca_vardnsmonom_isvalue	0
#define ca_vardnsmonom_pervalue 0

typedef ca_vardnsmonom_t ca_vardns_t;
typedef ca_vardnsmonom_t ca_vardns_c;
typedef ca_vardnsmonom_args ca_vardns_args;

#define ca_vardns_isvalue	0
#define ca_vardns_pervalue	1

typedef struct ca_vardns_ix {
    int i;
    int n;
} *ca_vardns_ixt;

@interface ca_vardns_monomial : ca_monomial
{
    id			termOne;
    id			symbols;
    ca_vardns_c		value;
}

- check;
- _setUpScalarOne:aOne symbols:aCltn;
+ scalarOne:aOne symbols:aCltn;
- copy;
- deepCopy;
- clear;
- clone;
- empty;
- (ca_vardns_t) ca_vardns_value;
- ca_vardns_value:(ca_vardns_t)aValue;
- (ca_vardns_c *) ca_vardns_reference;
- ca_vardns_reference:(ca_vardns_c *)aReference;
- (ca_vardnsmonom_t) ca_vardnsmonom_value;
- ca_vardnsmonom_value:(ca_vardnsmonom_t)aValue;
- (ca_vardnsmonom_c *) ca_vardnsmonom_reference;
- ca_vardnsmonom_reference:(ca_vardnsmonom_c *)aReference;
- (BOOL) sameClass:b;
- (int) numTerms;
- (BOOL) isEmpty;
- (BOOL) isOne;
- (int) compare:b;
- (BOOL) isEqual:b;
- (unsigned) hash;
- eachTerm;
- elt_ca_vardns_ix:(ca_vardns_ixt)ix;
- removeTerm;
- insertTerm:aTerm;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
@end

#endif /* __ca_vardns_monomial_header__ */

