
/*
 * Computer Algebra Kit (c) 1993,98 by Comp.Alg.Objects.  All Rights Reserved.
 */

#ifndef __ca_obj_vector_header__
#define __ca_obj_vector_header__

#include "vectorc.h"

typedef struct ca_objvec {
    int		n;
    int		c;
    ca_objseq_t	ptr;
} *ca_objvec_t;

typedef struct ca_objvec ca_objvec_c;
typedef struct { ca_obj_args sargs; } ca_objvec_args;

#define ca_objvec_isvalue	0
#define ca_objvec_pervalue	0

typedef struct ca_objvec_ix {
    int i;
    int n;
} *ca_objvec_ixt;

@interface ca_obj_vector : ca_vector
{
    id				scalarZero;
    struct ca_objvec		value;
}

- check;

- _setUpScalarZero:aScalarZero numScalars:(int)numScalars;
+ scalarZero:aScalarZero numScalars:(int)numScalars;
- copy;
- deepCopy;
- clear;
- (ca_objvec_t)ca_objvec_value;
- ca_objvec_value:(ca_objvec_t)aValue;
- (ca_objvec_t)ca_objvec_reference;
- ca_objvec_reference:(ca_objvec_c *)aReference;

- clone;
- capacity:(int)aCapacity;
- numScalars:(int)numScalars;

- scalarZero;
- (int) numScalars;

- insertScalar:aScalar;
- insertScalar:aScalar at:(int)i;

- removeScalar;
- removeScalarAt:(int)i;

- placeScalar:aScalar at:(int)i;
- replaceScalarAt:(int)i with:aScalar;

- eachScalar;
- elt_ca_objvec_ix:(ca_objvec_ixt)ix;

- dotMultiply:b;
- dotSquare;

- fileOutOn:aFiler;
- fileInFrom:aFiler;
- (unsigned) hash;
- (BOOL) isEqual:b;
- (BOOL) notEqual:b;
- (BOOL) isZero;
- (BOOL) notZero;
- (BOOL) isOpposite:b;
- (BOOL) notOpposite:b;
- negate;
- negateSelf;
- _double:(int)v;
- _doubleSelf:(int)v;
- double;
- doubleSelf;
- _add:(int)v:b:(int)w;
- _addSelf:(int)v:b:(int)w;
- add:b;
- addSelf:b;
- subtract:b;
- subtractSelf:b;
- multiplyScalar:s;
- multiplySelfScalar:s;
- divideScalar:s;
- divideSelfScalar:s;
- _add:(int)v:B multiplyScalar:b:(int)w;
- _addSelf:(int)v:B multiplyScalar:b:(int)w;
- _multiplyScalar:a:(int)v add:B:(int)w;
- _multiplySelfScalar:a:(int)v add:B:(int)w;
- _multiplyScalar:a:(int)v add:B multiplyScalar:b:(int)w;
- _multiplySelfScalar:a:(int)v add:B multiplyScalar:b:(int)w;
@end

#endif /* __ca_obj_vector_header__ */

