
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 *
 * DO NOT EDIT -- configure objc1.8.7 powerpc-be-beos
 */

#include "config.h"
#include <stdio.h>     /* printf,tmpnam */
#include <stdlib.h>    /* getenv */
#include <signal.h>    /* signal */
#include "objpak.h"
#include <string.h>    /* strtok */

/*
 * This program is supposed to be exactly equivalent in functionality
 * to the Bourne shell driver "objc".  The only difference being that it
 * is written in Objective C (for the MS-DOS port, or any platform where
 * we don't have a /bin/sh).
 *
 * Note that objc.exe is not the compiler itself: the compiler is called
 * objc1.
 * It is the "driver" for the different steps (cpp,objc1,cc etc.) involved
 * in compiling an Objective C file.
 *
 * Ideally, we would have been able to use a Bourne shell driver
 * on all platforms, because it has many advantages (in terms of
 * flexibility)
 * over a compiled, binary, driver.  For now, we try to maintain the two
 * implementations in parallel.  And a binary version has the potential
 * advantage of being faster (although we're sceptical...).
 *
 * On MS-DOS, only this program is available (as OBJC.EXE).
 * On UNIX, "objc" is the Bourne shell driver, which can be configured to
 * invoke this program (objc.exe), or objc.exe can simply be renamed "objc".
 */

BOOL PRECOMPILE = YES;
BOOL COMPILE = YES;
BOOL LINK = YES;
BOOL LINKDL = NO;
BOOL INCLUDE = YES;
BOOL USELIBS = YES;
BOOL BLOCKS = YES;
BOOL PPI = NO;
BOOL VERBOSE = NO;
BOOL PRINTFSYSTEM = 0;
BOOL DEBUG = NO;
BOOL DYNAMIC = NO;
BOOL RETAIN = NO;
BOOL RETAINCPP = NO;
BOOL PROFILE = NO;
BOOL USEOUTPUT = NO;
BOOL CPLUSPLUS = NO;
BOOL POSTLINK = 1;
BOOL SHORTCMDLINE = 0; 
BOOL RUNXSTR = NO;

STR  OBJSUFFIX = "o"; /* o/obj for UNIX/DOS */
STR  LIBSUFFIX = "a"; /* a/lib for UNIX/DOS */
STR  CPPSUFFIX = "P"; /* .P sometimes .i if it's hardcoded */
STR  DOTOBJSUFFIX = ".o"; /* o/obj for UNIX/DOS */
STR  DOTLIBSUFFIX = ".a"; /* a/lib for UNIX/DOS */
STR  DOTDLLSUFFIX = ".dll";

STR  CCMINUSCFLAG = "-c "; /* -c on UNIX, empty on WATCOM/MPW */
STR  CCMINUSOFLAG = "-o "; /* -o on UNIX, -fo= on WATCOM */
STR  LDMINUSOFLAG = "-o "; /* -o on UNIX, /OUT: on MSVC */
STR  CCMINUSIFLAG = "-I"; /* -I on UNIX, -i= on WATCOM */
STR  CCMINUSDFLAG = "-D"; /* -D on UNIX, -d  on MPW */
STR CPPMINUSOFLAG = "> "; /* > on UNIX, -fo= on WATCOM */

STR   PICFLAG = "-fpic";
STR STATICFLAG = "-static";
STR PICOCARGS = "";
STR    DLARGS = "-bogus";
STR    DLFILE = "";
STR DLXLDARGS = "";
STR DLXCCARGS = "";

STR LINKFORMAT = "metrowerks"; /* unix or watcom */

/*
 * Utilities for verbose logging.
 */

static void setBOOL(BOOL *global,const char *name,BOOL value)
{
	if (VERBOSE) printf("%s=%s\n",name,(value)?"YES":"NO");
	*global = value;
}

static void setString(id *global,const char *name,id value)
{
	if (VERBOSE) printf("%s=\"%s\"\n",name,[value str]);
	*global = value;
}

STR PATHSEP;

static void defaultPATHSEP(void)
{
	PATHSEP = getenv("OBJCPATHSEP");
	PATHSEP = (PATHSEP)?PATHSEP:OBJCRT_DEFAULT_PATHSEPC;
}

/*
 * Default value for OBJCDIR.
 * Defaults to "INSTALLDIR", can be set as environment variable.
 * Can also later be overridden using the -B option.
 */

id OBJCDIR;

static void defaultOBJCDIR(void)
{
	char *s = getenv("OBJCDIR");
	/* use INSTALLDIRC, not INSTALLDIR here (for double backslash) */
	setString(&OBJCDIR,"OBJCDIR",[String str:(s)?s:"/boot/apps/GeekGadgets"]);
}

/*
 * Set values for bin, lib and include directories.
 * Using OBJCDIR but only after -B option.
 */

id BINDIR;
id LIBDIR;
id HDRDIR;

static id pathConcat(id path,char *element)
{
	return [String sprintf:"%s%s%s",[path str],PATHSEP,element];
}

static id makeD(char *element)
{
	/* this can be -Delement, -d element */
	return [String sprintf:"%s%s",CCMINUSDFLAG,element];
}

static id makeI(char *element)
{
	id path = pathConcat(HDRDIR,element);
	/* this can be -Ipath, -i path, or -i=path */
	return [String sprintf:"%s%s",CCMINUSIFLAG,[path str]];
}

static id makeO(char *element)
{
	if (strlen(CCMINUSOFLAG)) {
	    /* this can be -o , -fo= etc. */
	    return [String sprintf:"%s%s",CCMINUSOFLAG,element];
	} else {
	    /* on LCC it's implicit, can't specify output */
	    return [String new];
	}
}

static id makeLDO(char *element)
{
	/* this can be -o, -fo=, /OUT: etc. */
	return [String sprintf:"%s%s",LDMINUSOFLAG,element];
}

static void setBINDIR(id prefix)
{
	setString(&BINDIR,"BINDIR",pathConcat(prefix,"bin"));
	setString(&LIBDIR,"LIBDIR",pathConcat(prefix,"lib"));
	setString(&HDRDIR,"HDRDIR",pathConcat(prefix,"include"));
}

/*
 * LIB stuff
 */

id LIBS;

static BOOL fileReadable(id INPUT)
{
	FILE *f;

	/*
	 * this compiles easier everywhere compared to stat() stuff
	 */
	
	f = fopen([INPUT str],"r");if (f) fclose(f);
	return f != NULL;
}

static id debugLib(id basename)
{
	return [[[basename copy] concatSTR:"_g"] concatSTR:DOTLIBSUFFIX];
}

static id sharedLib(id basename)
{
	return [[[basename copy] concatSTR:"_s"] concatSTR:DOTLIBSUFFIX];
}

static id profileLib(id basename)
{
	return [[[basename copy] concatSTR:"_p"] concatSTR:DOTLIBSUFFIX];
}

static id staticLib(id basename)
{
	return [[basename copy] concatSTR:DOTLIBSUFFIX];
}

static void addLib(id basename)
{
	id lib;

	if (PROFILE) {
	   lib = profileLib(basename);
	   if (fileReadable(lib)) {[LIBS add:lib];return;}
	}
	
	if (DEBUG) {
	   lib = debugLib(basename);
	   if (fileReadable(lib)) {[LIBS add:lib];return;}
	}

	if (DYNAMIC) {
	   lib = sharedLib(basename);
	   if (fileReadable(lib)) {[LIBS add:lib];return;}
	}

	lib = staticLib(basename);
	if (fileReadable(lib)) {[LIBS add:lib];}
}

static void addLibs(void)
{
	addLib(pathConcat(LIBDIR,"libcakit"));
	addLib(pathConcat(LIBDIR,"objpak"));
	addLib(pathConcat(LIBDIR,"objcrt"));
}

/*
 * The default INITCALL for NeXT is oc_objcInit (to avoid a name
 * clash with their runtime initializer _objcInit).  On all other
 * platforms it is currently _objcInit.
 *
 * For cross compiles, the -init option overrides the value set here.
 */

id INITCALL;

static void defaultINITCALL(void)
{
	setString(&INITCALL,"INITCALL",[String str:"_objcInit"]);
}

/*
 * Some binary names.
 */

id CC;
id CCPLUS;
id LD;
id POSTLINKEXE;
id CPP;
id XSTR;
id CPPFILTER;
id OBJC1FILTER;
id XSTRDB;

static void defaultBins()
{
char*s;
	
s = getenv("CC");
CC = ([String str:(s)?s:"mwcc"]);
	
s = getenv("CCPLUS");
CCPLUS = ([String str:(s)?s:"c++"]);
	
s = getenv("CPP");
CPP = ([String str:(s)?s:"mwcc -E"]);

s = getenv("LD");
LD = ([String str:(s)?s:"mwld"]);

XSTR= ([String str:"xstr"]);
	
s = getenv("CPPFILTER");
CPPFILTER = ([String str:(s)?s:""]);
	
s = getenv("OBJC1FILTER");
OBJC1FILTER = ([String str:(s)?s:""]);
}

/*
 * Default Argument Lists.
 * These are implemented as Collection instances, so that we can later
 * easily add additional String instances.
 */

id CPARGS;
id OCARGS;
id CCARGS;
id LDARGS;

static id addIfNonEmpty(id aCltn,char *s)
{
	id str = [String str:s];if ([str size]) [aCltn add:str];
	return aCltn;
}

static void defaultArgs(void)
{
	CPARGS = addIfNonEmpty([Collection new],"-D__PORTABLE_OBJC__ ");
	OCARGS = addIfNonEmpty([Collection new],"-refBind");
	CCARGS = addIfNonEmpty([Collection new],"");
	LDARGS = addIfNonEmpty([Collection new],"");
}

/*
 * Default Inputs.
 */

id OUTPUT;
id ACTIONC;
id INPUTS;
id EXTENSIONS;
id ACTIONS;

/* default output "a.exe" for DOS, "a.out" on UNIX */
STR aout = "a.out";

static void defaultInputs(void)
{
	OUTPUT     = [String str:aout];
	ACTIONC    = [String str:"c"];
	INPUTS     = [Collection new];
	EXTENSIONS = [Collection new];
	ACTIONS    = [Collection new];
}

/*
 * All Defaults.  Assumed to be called before driverOptions().
 */

static void driverDefaults(void)
{
	defaultPATHSEP();
	defaultOBJCDIR();
	defaultBins();
	defaultArgs();
	defaultInputs();
	defaultINITCALL();

	LIBS = [Collection new];
}

/*
 * Version and Usage messages.
 */

static void dumpFile(FILE *f)
{
	char linebuf[BUFSIZ + 1];
	
	while (!feof(f)) {
		if (fgets(linebuf,BUFSIZ,f)) fputs(linebuf,stdout);
	}
}

/* system cat will not work on the Mac */
static void dumpFileNamed(STR s)
{
	FILE *f;
	
	if ((f = fopen(s,"r"))) {
		dumpFile(f);fclose(f);
	} else {
		printf("objc: can't access %s\n",s);
	}
}

static void driverUsage(void)
{
        id n;
	setBINDIR(OBJCDIR); /* force def */
	n = pathConcat(LIBDIR,"objchelp.txt");
	if (!fileReadable(n)) fprintf(stderr,"objc: can't open %s",[n str]);
	dumpFileNamed([n str]);
}

static void driverVersion(void)
{
	printf("Portable Object Compiler - objc1.8.7 - powerpc-be-beos\n");
	printf("Distributed under the terms of the GNU LGPL.");
}

/*
 * Auxiliaries for parsing command line arguments.
 */

static int myStrLen(const char *s)
{
	int c = 0;while (*s++) c++;return c;
}

static BOOL prefixTest(const char *s,const char *prefix)
{
	int c;
	while ((c = *prefix++)) if (*s++ != c) return NO;
	return YES;
}

#define strEq(x,y) (strcmp((x),(y)) == 0)

static BOOL suffixTest(const char *s,const char *suffix)
{
	int c;
	s += myStrLen(s) - myStrLen(suffix);
	while ((c = *suffix++)) if (*s++ != c) return NO;
	return YES;
}

static id removePrefix(id arg,const char *prefix)
{
	return [String str:[arg str] + myStrLen(prefix)];
}

static id replaceSuffix(id INPUT,id oldSuffix,STR newSuffix)
{
    if ([INPUT size] >= [oldSuffix size]) {
    id res = [String chars:[INPUT str] count:[INPUT size] - [oldSuffix size]];
    [res concatSTR:newSuffix];
    return res;
    } else {
	return [INPUT copy];
    }
}

/*
 * Mac libs to link by default (allow to override with env.var).
 */

#define OBJC_SIOUX_LIBS "\"{MWPPCLibraries}MathLib\" \"{MWPPCLibraries}InterfaceLib\" \"{MWPPCLibraries}MSL RuntimePPC.Lib\" \"{MWPPCLibraries}MSL C.PPC.Lib\""

#define OBJC_MPW_LIBS "\"{MWPPCLibraries}MathLib\" \"{MWPPCLibraries}InterfaceLib\" \"{MWPPCLibraries}MSL MPWCRuntime.Lib\" \"{MWPPCLibraries}MSL MPW C.PPC.Lib\" \"{MWPPCLibraries}PPCToolLibs.o\""

#define OBJC_APPL_LIBS "\"{MWPPCLibraries}MathLib\" \"{MWPPCLibraries}InterfaceLib\" \"{MWPPCLibraries}MWStdCRuntime.Lib\" \"{MWPPCLibraries}StdCLib\" \"{MWPPCLibraries}PPCToolLibs.o\""

/*
 * Parsing command line arguments.
 */
 
#define argEq(x) ([ARG isEqualSTR:x])
#define prefixEq(x) (prefixTest([ARG str],x))
#define suffixEq(x) (suffixTest([ARG str],x))
#define shiftARG() (ARG = [ARGS next])

static id optionsNamed(id aCltn,STR s);

static void driverOptions(id ARGS)
{
	id ARG;
	
	while ((ARG = [ARGS next])) {

	        /* option for DOS where we have limits on cmd line length */
		if (prefixEq("@")) {
		    id cltn;
		    id name = removePrefix(ARG,"@");

		    if ((cltn = optionsNamed([Collection new],[name str]))) {
			driverOptions([cltn eachElement]);
		    } else {
			fprintf(stderr,"objc: no '%s' file or env.variable",
		        [name str]);
			exit(-1);
		    }

		    continue;
		}
		
		if (argEq("-c")) {
		/* on WATCOM we don't pass -c to the compiler
		 * it defaults to -c mode (for linking we use wlink)
		 */
			[CCARGS add:[String str:CCMINUSCFLAG]];
			LINK=NO;continue;
		}
		
		if (argEq("-C")) { LINK=NO;COMPILE=NO;RETAIN=YES;continue; }

		if (argEq("-objc") || argEq("-ObjC")) {
		 	ACTIONC=[String str:"m"];continue;
		}

		if (argEq("-dollars")) {
		      [CCARGS add:[String str:"-fdollars-in-identifiers"]];
		      continue;
		}

		if (argEq("-ObjCpp")) {
		      [CPARGS add:[String str:"-x objective-c -Wno-import"]];
		      continue;
		}

		if (argEq("-cplus")) {
		 	CPLUSPLUS=YES;POSTLINK=YES;continue;
		}
		
		if (argEq("-dump")) {
			LINK = NO;COMPILE = NO;RETAIN = YES;
			[OCARGS add:[String str:"-objc"]];continue;
		}

		if (argEq("-export")) {
			[OCARGS add:ARG];[OCARGS add:shiftARG()];continue;
		}

		if (argEq("-dllexport")) {
			[OCARGS add:ARG];continue;
		}
		
		if (argEq("-E")) { [CPARGS add:ARG];continue; /* ugh ? */ }
		
		if (argEq("-N")) { [CPARGS add:ARG];continue; }

		if (argEq("-nostdinc")) { [CPARGS add:ARG];continue; }

		if (argEq("-ppi")) {
		    [OCARGS add:ARG];
		    [OCARGS add:[String str:"-oneperfile"]];
		    [CCARGS add:[String str:"-fdollars-in-identifiers"]];
		    [CPARGS add:[String str:"-x objective-c -Wno-import"]];
		    PPI=1;
		    continue;
		}
		
		if (argEq("-noobjcinc") || argEq("-noI")) { INCLUDE = NO; continue; }
		
		if (argEq("-noLibs")) { USELIBS = NO; continue; }

		if (argEq("-noBlocks")) { BLOCKS = NO; continue; }

		if (argEq("-noFiler")) { [OCARGS add:ARG]; continue; }

		if (argEq("-noSelfAssign")) { [OCARGS add:ARG]; continue; }

		if (argEq("-noCategories")) { [OCARGS add:ARG]; continue; }

		if (argEq("-noCache")) { [OCARGS add:ARG]; continue; }

		if (argEq("-noNilRcvr")) { [OCARGS add:ARG]; continue; }

		if (argEq("-debugInfo")) { [OCARGS add:ARG]; continue; }

		/* watcom debug */
		if (argEq("-d0")||argEq("-d1")||argEq("-d1+")
		  ||argEq("-d2t")||argEq("-d2i")||argEq("-d2")
		  ||argEq("-d3")) {
		    DEBUG = YES;
		    [CCARGS add:ARG];
		    continue;
		}

		/* watcom building dll's */
		/* difference with -pic is that -pic also does -dllexport*/
		if (argEq("-bd")||argEq("-br")) {
		    [CCARGS add:ARG]; continue; 
		}

		/* watcom building for dos4g etc. */
		if (prefixEq("-bt=")) { [CCARGS add:ARG]; continue; }

		/* watcom turn off optimize */
		if (argEq("-od")) { [CCARGS add:ARG]; continue; }

		/* watcom some optimize option combinations */
		if (argEq("-oneatxh")) { [CCARGS add:ARG]; continue; }

		/* watcom stack overflow checks */
		if (argEq("-s")) { [CCARGS add:ARG]; continue; }

		/* watcom register/stack calling conventions */

		if (argEq("-3r")) { [CCARGS add:ARG]; continue; }
		if (argEq("-3s")) { [CCARGS add:ARG]; continue; }
		if (argEq("-4r")) { [CCARGS add:ARG]; continue; }
		if (argEq("-4s")) { [CCARGS add:ARG]; continue; }
		if (argEq("-5r")) { [CCARGS add:ARG]; continue; }
		if (argEq("-5s")) { [CCARGS add:ARG]; continue; }
		if (argEq("-6r")) { [CCARGS add:ARG]; continue; }
		if (argEq("-6s")) { [CCARGS add:ARG]; continue; }

		/* Macintosh mpw debug -sym on */
		if (argEq("-sym")) {
		    [CCARGS add:ARG];
		    ARG = shiftARG();
		    [CCARGS add:ARG];
		    DEBUG = argEq("on");
		    continue;
		}

		/* Macintosh mpw optimizing flags */
		if (argEq("-opt")) {
		    [CCARGS add:ARG];
		    [CCARGS add:shiftARG()];
		    continue;
		}

		if (argEq("-g")) { DEBUG = YES; [CCARGS add:ARG]; continue; }

		/* UNIX style -o flag to native style */
		if (argEq("-o")) {
			USEOUTPUT = YES;OUTPUT = shiftARG();continue;
		}
		
		if (argEq("-pg")) {
			PROFILE = YES;[LDARGS add:ARG];[CCARGS add:ARG];continue;
		}
		
		if (argEq("-q") || argEq("-quiet")) {
			[OCARGS add:[String str:"-quiet"]];continue;
		}
		
		if (argEq("-u") || argEq("-unbuf")) {
			[OCARGS add:[String str:"-u"]];continue;
		}
		
		if (argEq("-help") || argEq("--help")) {
			driverUsage();exit(0);
		}
		
		if (argEq("-usage") || argEq("--usage")) {
			driverUsage();exit(0);
		}
		
		if (argEq("-version") || argEq("--version")) {
			driverVersion();exit(0);
		}
		
		if (argEq("-init")) { INITCALL = shiftARG(); continue; }

		if (argEq("-main")) { 
		    [OCARGS add:ARG];[OCARGS add:shiftARG()]; continue; 
		}

		if (argEq("-builtinfunction")||argEq("-builtinFunction")) { 
		    [OCARGS add:[String str:"-builtinfunction"]];
		    [OCARGS add:shiftARG()];
		    continue; 
		}
		
		if (argEq("-builtintype")||argEq("-builtinType")) { 
		    [OCARGS add:[String str:"-builtintype"]];
		    [OCARGS add:shiftARG()]; 
		    continue; 
		}
		
		if (argEq("-retain")) { RETAIN = YES; RETAINCPP = YES; continue; }

		if (argEq("-retaincpp")) { RETAINCPP = YES; continue; }

		if (argEq("-xstr")) { RUNXSTR = YES; XSTRDB = shiftARG(); continue; }

		if (argEq("-noSelTbl")) { [OCARGS add:ARG];continue; }

		if (argEq("-undef")) { [CPARGS add:ARG];[CCARGS add:ARG];continue; }

		if (argEq("-mpwtool")) {
			STR t = getenv("OBJCMPWLIBS");
			t = (t)?t:OBJC_MPW_LIBS;
			/* the following works with MWLinkPPC and PPCLink */
			[LDARGS add:[String str:"-c 'MPS ' -t MPST"]];
			/* depends on MWLinkPPC and PPCLink */
			[LIBS add:[String str:t]];
			continue;
		}

		if (argEq("-sioux")) {
			STR t = getenv("OBJCSIOUXLIBS");
			t = (t)?t:OBJC_SIOUX_LIBS;
			/* Metrowerks Sioux app */
			[LIBS add:[String str:t]];
			continue;
		}

		if (argEq("-appl")) {
			STR t = getenv("OBJCAPPLLIBS");
			t = (t)?t:OBJC_APPL_LIBS;
			/* regular Mac app */
			[LIBS add:[String str:t]];
			continue;
		}
		
		if (argEq("-static")) {
		    [LIBS add:[String str:STATICFLAG]];continue;
		}

		if (argEq("-pic")) {
		    [CCARGS add:[String str:PICFLAG]];
		    [OCARGS add:[String str:PICOCARGS]]; /* like -dllexport */
		    [OCARGS add:[String str:"-noShared"]];

		    /* idea here is to not define objcInit() when compiling
		     * objcrt as a DLL (with -pic)
		     * this means that user will *have* to use -dynamic
		     * to use the DLL
		     */

		    [CPARGS add:makeD("OBJCRT_NOSHARED")];
		    continue; 
		}

		if (argEq("-fpic")) { [CCARGS add:ARG];continue; }
		if (argEq("+z")) { [CCARGS add:ARG];continue; }
		if (argEq("+Z")) { [CCARGS add:ARG];continue; }

		if (argEq("-dl")) {
		    LINKDL = YES;POSTLINK= YES;continue;
		}

		if (argEq("-dlx") || argEq("-dynamic")) {
		    [LDARGS add:[String str:DLXLDARGS]];
		    [CCARGS add:[String str:DLXCCARGS]];
		    [OCARGS add:[String str:"-noShared"]];
		    INITCALL = [String str:"_objcInitNoShared"];
		    DYNAMIC  = YES;
		    continue;
		}

		if (argEq("-linkFormat")) {
			LINKFORMAT = [shiftARG() str];continue;
		}

		/* metrowerks MWLinkPPC */
		if (argEq("-xm")) {
		    [LDARGS add:ARG];
		    [LDARGS add:shiftARG()]; /* app,sharedlibrary,mpwtool */
		    continue;
		}
		
		if (argEq("-inlinecache") || argEq("-inlineCache")) 
			{ [OCARGS add:[String str:"-inlinecache"]];continue; }

		if (argEq("-oneperfile")) { [OCARGS add:ARG];continue; }

		if (argEq("-printfSystem") || argEq("-check"))
		        { PRINTFSYSTEM=1;continue; }

		if (argEq("-cthreads")) {
			[OCARGS add:ARG];
			[CPARGS add:makeD("OBJCRT_CTHREADS")];
			continue;
		}

		if (argEq("-pthreads")) {
			[OCARGS add:ARG];
			[CPARGS add:makeD("OBJCRT_PTHREADS")];
			[LIBS add:[String str:"-lpthread"]];
			continue;
		}

		if (argEq("-gc") || argEq("-boehm")) {
			[OCARGS add:[String str:"-boehm"]];
			[CPARGS add:makeD("OBJCRT_BOEHM")];
			/* force definition of LIBDIR */
			setBINDIR(OBJCDIR);
			addLib(pathConcat(LIBDIR,"gc"));
			continue;
		}

		if (argEq("-postlink") || argEq("-postLink")) {
			POSTLINK=YES;continue;
		}

		if (argEq("-noPostlink") || argEq("-noPostLink")) {
			POSTLINK=NO;continue;
		}
		
		if (argEq("-nolinetags") || argEq("-noTags")) {
			[OCARGS add:[String str:"-nolinetags"]];continue;
		}

		if (argEq("-shortTags")) {
			[OCARGS add:ARG];continue;
		}

		if (argEq("-objc1trace")) {
			[OCARGS add:[String str:"-trace"]];continue;
		}

		if (argEq("-v") || argEq("-verbose")) { VERBOSE = YES; continue; }
	        if (argEq("-w")) {
			[OCARGS add:[String str:"-wClassUsedAsType"]];
			[OCARGS add:[String str:"-wUndefinedMethod"]];
			[OCARGS add:[String str:"-wInterfaceNotFound"]];
			[OCARGS add:[String str:"-wLocalInstance"]];
			continue;
		}

		if (argEq("-wClassUsedAsType")) {
			[OCARGS add:ARG];
			continue;
		}

		if (argEq("-wLocalInstance")) {
			[OCARGS add:ARG];
			continue;
		}

		if (argEq("-wUndefinedMethod")) {
			[OCARGS add:ARG];
			continue;
		}

		if (argEq("-wInterfaceNotFound")) {
			[OCARGS add:ARG];
			continue;
		}

		if (argEq("-Wall")) {
			[CCARGS add:ARG];
			continue;
		}

		if (argEq("-WLex")) {
			[OCARGS add:ARG];
			continue;
		}
		
		if (prefixEq("-cpOpt:")) {
			[CPARGS add:removePrefix(ARG,"-cpOpt:")];
			continue;
		}

		if (prefixEq("-cppOpt:")) {
			[CPARGS add:removePrefix(ARG,"-cppOpt:")];
			continue;
		}

		if (prefixEq("-ocOpt:")) {
			[OCARGS add:removePrefix(ARG,"-ocOpt:")];
			continue;
		}

		if (prefixEq("-objc1Opt:")) {
			[OCARGS add:removePrefix(ARG,"-objc1Opt:")];
			continue;
		}

		if (prefixEq("-ccOpt:")) {
			[CCARGS add:removePrefix(ARG,"-ccOpt:")];
			continue;
		}
		
		if (prefixEq("-ldOpt:")) {
			[LDARGS add:removePrefix(ARG,"-ldOpt:")];
			continue;
		}

		if (argEq("-64")) { [CCARGS add:ARG];continue; }

		if (argEq("-32")) { [CCARGS add:ARG];continue; }

		if (argEq("-n32")) { [CCARGS add:ARG];continue; }

		if (argEq("-noobject")) { [CCARGS add:ARG];continue; }

		if (argEq("-migrate")) { [CCARGS add:ARG];continue; }

		if (argEq("-assume")) {
			[CCARGS add:ARG];
			[CCARGS add:shiftARG()];
			continue;
		}

		if (prefixEq("-mips")) { [CCARGS add:ARG];continue; }

		if (prefixEq("-w")) { [CCARGS add:ARG];continue; }

		if (prefixEq("-edit")) { [CCARGS add:ARG];continue; }

		if (suffixEq(".m")) {
			[INPUTS add:ARG];
			[EXTENSIONS add:[String str:"m"]];
			[ACTIONS add:[String str:"m"]];
			continue;
		}
		
		if (suffixEq(".c")) {
			[INPUTS add:ARG];
			[EXTENSIONS add:[String str:"c"]];
			[ACTIONS add:ACTIONC];
			continue;
		}
		
		if (suffixEq(".cc")) {
			[INPUTS add:ARG];
			[EXTENSIONS add:[String str:"cc"]];
			[ACTIONS add:[String str:"cc"]];
			CPLUSPLUS=YES;POSTLINK=YES;
			continue;
		}
		
		if (suffixEq(".mm")) {
			[INPUTS add:ARG];
			[EXTENSIONS add:[String str:"mm"]];
			[ACTIONS add:[String str:"mm"]];
			CPLUSPLUS=YES;POSTLINK=YES;
			continue;
		}
		
		/* for matching the dot is important */
		if (suffixEq(DOTOBJSUFFIX)) {
			[INPUTS add:ARG];
			[EXTENSIONS add:[String str:OBJSUFFIX]];
			[ACTIONS add:[String str:OBJSUFFIX]];
			continue;
		}

		if (suffixEq(DOTLIBSUFFIX)) {
		        [LIBS add:ARG];
			continue;
		}

		if (suffixEq(".so")) {
		        [LIBS add:ARG];
			continue;
		}

		/* try to translate to native style (-d ) on MPW */
		if (prefixEq("-D")) {
			id e = removePrefix(ARG,"-D");e = makeD([e str]);
			[CPARGS add:e];[CCARGS add:e];continue;
		}

		if (prefixEq("-U")) {
			[CPARGS add:ARG];[CCARGS add:ARG];continue;
		}

		/* accept native convention (-i) on MPW */
		if (argEq(CCMINUSIFLAG)) {
			[CPARGS add:ARG];[CPARGS add:shiftARG()]; continue;
		}

		/* accept native convention (-i= etc.) on WATCOM */
		if (prefixEq(CCMINUSIFLAG)) { [CPARGS add:ARG];continue; }

		/* try to translate UNIX option to native style */
		if (prefixEq("-I")) {
			id path = removePrefix(ARG,"-I");
			[CPARGS add:[String sprintf:"%s%s",CCMINUSIFLAG,[path str]]];
			continue;
		}
		
		if (prefixEq("-L")) { [LIBS add:ARG];continue; }
		if (prefixEq("-l")) { [LIBS add:ARG];continue; }
		
		if (prefixEq("-O")) { [CCARGS add:ARG];continue; }
		
		if (prefixEq("-B")) { OBJCDIR = removePrefix(ARG,"-B");continue; }
	
		fprintf(stderr,"objc: Illegal option or file %s\n",[ARG str]);
		exit(1);
	}
}

/*
 * This implements the "set $OBJCOPT $*" that we have in the beginning
 * of the Bourne shell driver.
 */

static id optionsFromString(id aCltn,char *s)
{
	char *p;
	char *delims = " \t\n\r";
	id buffer = [String str:s];
	
	p = strtok([buffer str],delims);
	
	while (p != NULL) {
		[aCltn add:[String str:p]];
		p = strtok(NULL,delims);
	}

	return aCltn;
}

static id optionsFromFile(id aCltn,FILE *f)
{
    char buf[BUFSIZ+1];

    while (!feof(f)) {
	if (fgets(buf,BUFSIZ,f)) {
	    /* this works 'cause strtok also deletes \n */
	    optionsFromString(aCltn,buf); 
	}
    }

    return aCltn;
}

/* this is mostly for MS-DOS cmd line length limitations */

static id optionsNamed(id aCltn,STR s)
{
	STR t;
	FILE *f;

	/* maybe there's such an environment variable */
	if ((t = getenv(s))) return optionsFromString(aCltn,t);

	/* maybe there's such a file */
	if ((f = fopen(s,"r"))) {
	    aCltn = optionsFromFile(aCltn,f);
	    fclose(f);return aCltn;
	}

	/* nope */
	return nil;	
}

static id eachARG(int argc,char **argv)
{
	id cltn = [Collection new];
	optionsNamed(cltn,"OBJCOPT"); /* no error if absent */
	while (argc--) [cltn add:[String str:*argv++]];
	return [cltn eachElement];
}

/*
 * These are assigned a value after driverOptions().
 */

id OBJC1;
id OBJFILES;
id OBJCPLUS1;

static void moreGlobals()
{
	/* because this is ran after driverOptions(),
	 * that is after VERBOSE is possibly set to YES,
	 * this is a good location for logging values to the user
	 */
	
	setBINDIR(OBJCDIR);
	setString(&CC,"CC",CC);
	setString(&CPP,"CPP",CPP);
	setString(&CPPFILTER,"CPPFILTER",CPPFILTER);
	setString(&OBJC1FILTER,"OBJC1FILTER",OBJC1FILTER);
	setString(&OBJC1,"OBJC1",pathConcat(BINDIR,"objc1"));
	setString(&OBJCPLUS1,"OBJCPLUS1",pathConcat(BINDIR,"objcpls1"));
	
	OBJFILES = [Collection new];
	
	if (CPLUSPLUS) {
		[OCARGS add:[String str:"-cplus"]];
	}

	setBOOL(&POSTLINK,"POSTLINK",POSTLINK);
	setString(&POSTLINKEXE,"postlink",pathConcat(BINDIR,"postlink"));
	
	if (POSTLINK) {
		[OCARGS add:[String str:"-postlink"]];
		[LDARGS add:[String str:"-map postlink.map"]];
	}	

	[[OCARGS add:[String str:"-init"]] add:INITCALL];

	if (INCLUDE) {
		[CPARGS add:makeI("objcrt")];
		[CPARGS add:makeI("objpak")];
		[CPARGS add:makeI("cakit")];
	}

	if (PPI) {
		[CPARGS add:makeI("ppi")];
	}

	
	if (BLOCKS) {
		[CPARGS add:makeD("OBJC_BLOCKS=1")];
	} else {
		[CPARGS add:makeD("OBJC_BLOCKS=0")];
		[OCARGS add:[String str:"-noBlocks"]];
	}
}

/*
 * Deleting temporary files.
 */

static BOOL systemCall(id command)
{
	/* the MPW driver can't use system() since, (although defined for ANSI)
	 * it doesn't do anything on the Mac.  we set PRINTFSYSTEM=1 for this
	 * driver (the commands are redirected to the MPW shell).
	 */
	
	if (VERBOSE || PRINTFSYSTEM) printf("%s\n",[command str]);

        /* in addition the metrowerks libs don't define system() at all */

#if OBJC_HAVE_SYSTEM_CALL
	return (PRINTFSYSTEM)?YES:(system([command str]) != -1);
#else
	return YES; /* no system() stub available, e.g. Metrowerks MWCPPC */
#endif
}

static id unlinkFile(id file)
{
#if 0
	char *s = [file str];

	/* we could do this using unlink(),
	 * but the header location is nonstandard
	 */
	if (VERBOSE) printf("removing %s\n",s);
	if (unlink(s) == -1) printf("error while removing %s\n",s);
#endif

	id cmd = [String sprintf:"rm -f %s",[file str]];
	if (!systemCall(cmd)) {
		fprintf(stderr,"objc: could not remove %s\n",[file str]);
		/* don't exit if "del" fails : sort of -f option */
	}
	
	return file;
}

static void unlinkFiles(id files)
{
	id file;while ((file = [files removeLast])) unlinkFile(file);
}

/*
 * SIGINT Handler.
 * Upon hitting Control-C, we unlink the files in JUNK.
 */

id JUNK;

static void driverExit(int status)
{
	unlinkFiles(JUNK);
	exit(status);
}

static void driverHandler(int i)
{
	printf("objc: *** Interrupt\n");

    	/* very unlikely to be a problem, but in
	 * theory you need to set noCacheFlag when
	 * sending objc messages from within a handler
	 * because the signal might have been delivered while
	 * the message lookup cache was being updated for one of
	 * the messages that is being sent from within the handler
	 */

#ifdef __PORTABLE_OBJC__
	noCacheFlag = 1;
#endif

	driverExit(1);
}

/*
 * Passing commands to the shell
 */

static id catSequence(id command,id ARGS)
{
	id ARG;
	while ((ARG = [ARGS next])) {
		[command concatSTR:" "];
		[command concatSTR:[ARG str]];
	}
	return command;
}

static void saveSequence(STR filename,id ARGS)
{
    FILE *f = fopen(filename,"w");

    if (f) {
     id ARG;
     while ((ARG = [ARGS next])) {fputs([ARG str],f);fputs(" ",f);}
     fclose(f);
    } else {
     fprintf(stderr,"objc: could not write options to file '%s'\n",filename);
    }

    /* ld.opt is twice added with same value */
    if (!RETAIN) [JUNK addIfAbsentMatching:[String str:filename]];
}

/*
 * driverCommand() takes two collections as arguments.
 * The first collection is passed in the WATCOM 10.0 case via a @file.
 * The second collection are those arguments that need to be specified
 * on the command line.
 */

static BOOL driverCommand(id command,STR optfile,id arguments,id filenames)
{
    id cmd;

    if (optfile != NULL && SHORTCMDLINE) {
	saveSequence(optfile,[arguments eachElement]);
	cmd = [[[command copy] concatSTR:" @"] concatSTR:optfile];
    } else {
	cmd = catSequence([command copy],[arguments eachElement]);
    }

    if (filenames) cmd = catSequence(cmd,[filenames eachElement]);
    return systemCall(cmd);
}

/*
 * Processing Inputs
 */

static id OUTPUTFor(id INPUT,id EXTENSION)
{
	if (USEOUTPUT && !LINK) {
	    return OUTPUT;
	} else {
	    return replaceSuffix(INPUT,EXTENSION,OBJSUFFIX);
	}
}

static void processO(id INPUT,id EXTENSION)
{
	[OBJFILES add:INPUT];
}

static void processA(id INPUT,id EXTENSION)
{
	/* for the WATCOM the difference matters (can't put it in OBJFILES) */
	[LIBS add:INPUT];
}

static BOOL driverCPP1(id INPUT,id RESULT)
{
	id cargs,filenames;

	cargs = [Collection new];
	[cargs addContentsOf:CCARGS]; /* can contain stuff like -ansi */
	[cargs addContentsOf:CPARGS]; /* CPP specific */

	filenames = [Collection new];
	[filenames add:INPUT];

	/* by setting CPPMINUSOFLAG, suppress output file (lcc -E case) */
	if (strlen(CPPMINUSOFLAG)) {
	/* '>' would for WATCOM redirect error messages into the file */
	[filenames add:[String sprintf:"%s%s",CPPMINUSOFLAG,[RESULT str]]];
	}

	return driverCommand(CPP,"cpp.opt",cargs,filenames);
}

/*
 * Ugly hack for SGI cc preprocessor.
 * On SGI (only there as far as I know, although that it may
 * happen on other systems) cc -E file.m is defining
 * FORTRAN_LANGUAGE.  In other words, it wants the suffix to be
 * .c of the file, or it doesn't consider the source file to be C.
 * We can work around this (by undefining FORTRAN_LANGUAGE etc.)
 * or by invoking the /lib/cpp directly instead of using the cc -E
 * interface, but this has many disadvantages (such as that our
 * work-around for IRIX5.3 didn't work on IRIX6,2).
 * I believe therefore that the best way to deal with this, is to
 * effectively make a .c copy of the input file before running cc -E.
 *
 * (might want to use a flag to only do this on SGI, or platforms that
 * need it)
 */

static BOOL makeTMPCViaCat(id mfile,id cfile)
{
	id cmd = [String sprintf:"cat %s > %s",[mfile str],[cfile str]];
	return systemCall(cmd);
}

static BOOL makeTMPC(id mfile,id cfile)
{
	if (PRINTFSYSTEM) {
		/* this is for MPW */
		return makeTMPCViaCat(mfile,cfile);
	} else {
		FILE *mf,*cf;
		
		cf = fopen([cfile str],"w");
		mf = fopen([mfile str],"r");
		
		if (cf!=NULL && mf!= NULL) {
			fprintf(cf,"#line 1 \"%s\"\n",[mfile str]);
			while (feof(mf) == 0) { int c = fgetc(mf);fputc(c,cf); }
			fclose(mf);fclose(cf);
			return YES;
		} else {
			return NO;
		}
	}
}

static BOOL haveFilter(id aFilter)
{
    return aFilter != nil
        && [aFilter isEqualSTR:"none"] == NO
        && [aFilter isEqualSTR:""] == NO;
}

static BOOL driverFilter(id aFilter,id INPUT,id RESULT)
{
	id cargs = [Collection new];

	[cargs add:INPUT];
	[cargs add:RESULT];

	return driverCommand(aFilter,NULL,cargs,nil);
}

static BOOL driverCPP(id INPUT,id EXTENSION,id RESULT)
{
	BOOL success;
	id FIXED = nil;
	BOOL fixFile = haveFilter(CPPFILTER);

	if (fixFile) {
	    FIXED = RESULT;
	    RESULT = replaceSuffix(INPUT,EXTENSION,CPPSUFFIX);
	    /* this might cause the .i file to be added twice,
	     * so use addIfAbsentMatching */
	    if (!RETAINCPP) [JUNK addIfAbsentMatching:RESULT];
	}

	if ([EXTENSION isEqualSTR:"c"]) {
		success = driverCPP1(INPUT,RESULT);	   
	} else {
		id TMPC = replaceSuffix(INPUT,EXTENSION,(CPLUSPLUS)?"cc":"c");
		success = makeTMPC(INPUT,TMPC);
		if (!RETAIN) [JUNK add:TMPC];
		if (success) success = driverCPP1(TMPC,RESULT);		
	}

	if (fixFile) {
	    if (success) success = driverFilter(CPPFILTER,RESULT,FIXED);
	}

	return success;
}

static BOOL driverOBJC(id NAME,id EXTENSION,id INPUT,id RESULT)
{
	id cargs;
	BOOL success;
	id FIXED = nil;
	BOOL fixFile = haveFilter(OBJC1FILTER);

	if (fixFile) {
	    FIXED = RESULT;
	    RESULT = replaceSuffix(NAME,EXTENSION,"ix");
	}

	cargs = [Collection new];
	[cargs addContentsOf:OCARGS];
	[cargs add:[String str:"-filename"]];
	[cargs add:NAME];
	[cargs add:INPUT];
	[cargs add:RESULT];

	success = driverCommand((CPLUSPLUS)?OBJCPLUS1:OBJC1,NULL,cargs,nil);
	
	if (fixFile) {
	    if (success) success = driverFilter(CPPFILTER,RESULT,FIXED);
	}

	return success;
}

static BOOL driverCC(id INPUT,id RESULT)
{
	id cargs;
	id filenames;
	
	/* normal operation of the WATCOM is '-c' */
	/* MPW compilers don't emit a .o file when given -c */

	cargs = [Collection new];
	cargs = [cargs add:[String str:CCMINUSCFLAG]];
	[cargs addContentsOf:CCARGS];

	filenames = [Collection new];
	[filenames add:INPUT];

	if (USEOUTPUT) {
		/* -fo= on WATCOM, -o on UNIX */
		[filenames add:makeO([RESULT str])];
	}

	return driverCommand((CPLUSPLUS)?CCPLUS:CC,"cc.opt",cargs,filenames);
}

/* this is for compiling _postlnk.c etc. (never use CPLUSPLUS here) */

static BOOL simpleCC(id INPUT,id ofile)
{
	id cargs,filenames;
	
	/* normal operation of the WATCOM is '-c' */
	/* MPW compilers don't emit a .o file when given -c */
	
	cargs = [Collection new];
	cargs = [cargs add:[String str:CCMINUSCFLAG]];
	[cargs addContentsOf:CCARGS];

	filenames = [Collection new];
	[filenames add:INPUT];
	/* result must be _postlnk.o,not _postlink.c.o, on MPW */
	filenames = [filenames add:makeO([ofile str])];

	return driverCommand(CC,"cc.opt",cargs,filenames);
}

static void processC(id INPUT,id EXTENSION)
{
	id RESULT = OUTPUTFor(INPUT,EXTENSION);
	
	if (COMPILE && driverCC(INPUT,RESULT)) {
		[OBJFILES add:RESULT];
	} else {
		driverExit(1);
	}
}

static void processM(id INPUT,id EXTENSION)
{
	id RESULT;
	id TMPP,TMPI;
	
	RESULT = OUTPUTFor(INPUT,EXTENSION);
	TMPP   = replaceSuffix(INPUT,EXTENSION,"P");
	TMPI   = replaceSuffix(INPUT,EXTENSION,(CPLUSPLUS)?"ii":"i");
	
	if (!RETAIN) [JUNK add:TMPI];
	if (!RETAINCPP) [JUNK add:TMPP];
	
	if (driverCPP(INPUT,EXTENSION,TMPP)) {
		if (PRECOMPILE && driverOBJC(INPUT,EXTENSION,TMPP,TMPI)) {
			if (COMPILE && driverCC(TMPI,RESULT)) {
				[OBJFILES add:RESULT];
			} else {
				driverExit(1);
			}
		} else {
			driverExit(1);
		}
	} else {
		driverExit(1);
	}

	unlinkFiles(JUNK);
}

static void processInput(id INPUT,id EXTENSION,id ACTION)
{
/* don't want this warning in MPW -printfSystem case */
#if 0
	if (!fileReadable(INPUT)) printf("objc: can't open %s\n",[INPUT str]);
#endif

	if ([ACTION isEqualSTR:"m"]) {
		processM(INPUT,EXTENSION);return;
	}
	if ([ACTION isEqualSTR:"mm"]) {
		processM(INPUT,EXTENSION);return;
	}
	if ([ACTION isEqualSTR:"c"]) {
		processC(INPUT,EXTENSION);return;
	}
	if ([ACTION isEqualSTR:"cc"]) {
		processC(INPUT,EXTENSION);return;
	}
	if ([ACTION isEqualSTR:OBJSUFFIX]) {
		processO(INPUT,EXTENSION);return;
	}
	if ([ACTION isEqualSTR:LIBSUFFIX]) {
		processA(INPUT,EXTENSION);return;
	}
}

static void processInputs(void)
{
	int i,n;
	for(i=0,n = [INPUTS size];i<n;i++) {
		processInput([INPUTS at:i],[EXTENSIONS at:i],[ACTIONS at:i]);
	}
}

/*
 * Processing Outputs
 */

/*
 * Regular link, using "ld".  Only possible if we have auto-initialization,
 * which requires support of the compiler for common storage of data.
 * UNIX compilers do this (on SGI it's an option).  WINDOWS does not.
 */

static BOOL unixLD(void)
{
	id ldargs,filenames;
	
	ldargs = [Collection new];
	[ldargs addContentsOf:LDARGS];
	[ldargs addContentsOf:OBJFILES];
	[ldargs addContentsOf:LIBS];

	filenames = [Collection new];
	[filenames add:makeLDO([OUTPUT str])];
	
	return driverCommand(LD,"ld.opt",ldargs,filenames);
}

/*
 * This function is used from within Postlink on WATCOM.
 * It is NOT the way the final program is linked on WATCOM.
 * Uses wlink syntax, which is not UNIX compatible.
 */

static BOOL watcomLD(void)
{
	id ldargs,filenames;
	
	/* LDARGS contains option map=postlink.map */
	ldargs = [Collection new];
	[ldargs addContentsOf:LDARGS];

	/* stes 11/97 include all debug info; there also exists
	 * "debug line" which maybe should be an option
	 */

	if (DEBUG) {
	    [ldargs add:[String str:"debug all"]];
	}

	if ([OBJFILES size]) {
		[ldargs add:[String str:"file {"]];
		[ldargs addContentsOf:OBJFILES];
		[ldargs add:[String str:"}"]];
	}
	
	if ([LIBS size]) {
		[ldargs add:[String str:"library { "]];
		[ldargs addContentsOf:LIBS];
		[ldargs add:[String str:" }"]];
	}

	filenames = [Collection new];
	[filenames add:[String sprintf:"name %s",[OUTPUT str]]];

	return driverCommand(LD,"ld.opt",ldargs,filenames);
}

/*
 * MPW using Metrowerks compiler.
 */

static BOOL metrowerksLD(void)
{
	return unixLD();
}

/*
 * Microsoft MS VC.  Configured for automatic runtime init by default.
 */

static BOOL msvcLD(void)
{
	return unixLD();
}

/*
 * IBM VisualAge for C++ on OS/2.  Configured for automatic runtime init
 * by default.
 */

static BOOL ibmvacLD(void)
{
	return unixLD();
}

static BOOL driverLD(void)
{
	if (strEq(LINKFORMAT,"unix")) return unixLD();
	if (strEq(LINKFORMAT,"watcom")) return watcomLD();
	if (strEq(LINKFORMAT,"mpw")) return metrowerksLD();
	if (strEq(LINKFORMAT,"metrowerks")) return metrowerksLD();
	if (strEq(LINKFORMAT,"msvc")) return msvcLD();
	if (strEq(LINKFORMAT,"ibmvac")) return ibmvacLD();
	fprintf(stderr,"objc: unknown link format '%s'",LINKFORMAT);
	return NO;
}

/*
 * POSTLINK stuff.
 */

static BOOL unixPostlink(id image,id cfile)
{
	id cmd;
	char *fmt = "nm %s | %s > %s"; /* default format is UNIX */
	
	cmd=[String sprintf:fmt,[image str],[POSTLINKEXE str],[cfile str]];
	
	return systemCall(cmd);
}

static BOOL watcomPostlink(id image,id cfile)
{
	id cmd;
	char *fmt = "%s -f watcom - postlink.map %s";

	if (!RETAIN) [JUNK add:[String str:"postlink.map"]];

	/* don't really need "image" unlike UNIX, but rather wlink map */
	/* this map is produced in the function watcomLD() */
	cmd = [String sprintf:fmt,[POSTLINKEXE str],[cfile str]];
	
	return systemCall(cmd);
}

static BOOL metrowerksPostlink(id image,id cfile)
{
	id cmd;
	id postlinkprogram = pathConcat(BINDIR,"postlink");
	char *fmt = "%s -f metrowerks - postlink.map %s";

	if (!RETAIN) [JUNK add:[String str:"postlink.map"]];

	/* don't really need "image" unlike UNIX, but rather MW map */
	/* this map is produced in the function metrowerksLD() */
	cmd=[String sprintf:fmt,[postlinkprogram str],[cfile str]];

	return systemCall(cmd);
}

static BOOL msvcPostlink(id image,id cfile)
{
    return watcomPostlink(image,cfile);
}

static BOOL ibmvacPostlink(id image,id cfile)
{
	id cmd;
	char *fmt = "%s -f ibmvac - postlink.map %s";

	if (!RETAIN) [JUNK add:[String str:"postlink.map"]];

	/* don't really need "image" unlike UNIX, but rather icc map */
	/* this map is produced in the function ibmvacLD() */
	cmd = [String sprintf:fmt,[POSTLINKEXE str],[cfile str]];
	
	return systemCall(cmd);
}

static BOOL makePostlink(id image,id cfile)
{
	if (strEq(LINKFORMAT,"unix")) return unixPostlink(image,cfile);
	if (strEq(LINKFORMAT,"watcom")) return watcomPostlink(image,cfile);
	if (strEq(LINKFORMAT,"msvc")) return msvcPostlink(image,cfile);
	if (strEq(LINKFORMAT,"mpw")) return metrowerksPostlink(image,cfile);
	if (strEq(LINKFORMAT,"metrowerks")) {
	    return metrowerksPostlink(image,cfile);
	}
	if (strEq(LINKFORMAT,"ibmvac")) return ibmvacPostlink(image,cfile);
	fprintf(stderr,"objc: unknown link format '%s'",LINKFORMAT);
	return NO;
}

/*
 * Just a utility for performing the double link of "postlink"
 */

static BOOL linkStep1(id ofile)
{
	[OBJFILES add:ofile];
	if (!driverLD()) return NO;
	return (ofile == [OBJFILES remove:ofile]);
}

static BOOL linkStep2(id cfile,id ofile)
{
	if (!simpleCC(cfile,ofile)) return NO;else return linkStep1(ofile);
}

static BOOL driverPOSTLINK(STR prelink)
{
	id opre,cpost,opost;
	
	cpost = [String str:"_postlnk.c"]; /* 8+3 filename ! */
	opost = [String sprintf:"_postlnk.%s",OBJSUFFIX];

	/* prelink is a library file */
	opre  = [String sprintf:"%s.%s",prelink,OBJSUFFIX];
	opre  = pathConcat(LIBDIR,[opre str]);

	if (!fileReadable(opre)) {
	    fprintf(stderr,"Can't find file %s.",[opre str]);exit(1);
	}
	
	[JUNK add:opost];
	if (!RETAIN) { [JUNK add:cpost]; }
	[JUNK add:OUTPUT];

	/* the executable produced in this first link will fail to work
	 * it serves to run "postlink" on (to generate a table of
	 * all classes in the image)
	 */
	
	if (!linkStep1(opre)) return NO;
	
	/* compile and link again */

	if (!makePostlink(OUTPUT,cpost)) return NO;
	if (!linkStep2(cpost,opost)) return NO;
	
	return (OUTPUT == [JUNK remove:OUTPUT]);
}

/*
 * Processing Outputs
 */

static void linkDynamicLibrary(void)
{
        id n;

	[LDARGS add:[String str:DLARGS]];

	/* small kludge, but already better than stuff
	 * that was here before (which was totally win32 specific)
	 * idea currently is to use -a option for postlink
	 * so this can be customized for each platform by having
	 * a specific objcdl file (objcdlnt.wat, objcdlos.vac  etc)
	 */

	n = pathConcat(LIBDIR,DLFILE);
	if (!fileReadable(n)) fprintf(stderr,"objc: can't open %s",[n str]);

	POSTLINKEXE = [POSTLINKEXE concatSTR:" -a "];
	POSTLINKEXE = [POSTLINKEXE concatSTR:[n str]];

	if (!driverPOSTLINK("_predll")) driverExit(1);
}

static void linkOutputs(void)
{
	if (USELIBS) addLibs();

	if (LINKDL) {
	    linkDynamicLibrary();
	} else {
	    if (POSTLINK) {
		    if (!driverPOSTLINK("_prelink")) driverExit(1);
	    } else {
		    if (!driverLD()) driverExit(1);
	    }
	}
}

/*
 * Entry point.
 */

void main(int argc,char **argv)
{
	/* remove JUNK contents on SIGINT */
	JUNK = [Collection new];
	signal(SIGINT,driverHandler);

	driverDefaults();
	
	if (argc==1) {
		driverVersion();driverUsage();exit(0);
	} else {
		driverOptions(eachARG(argc - 1,argv + 1));
	}
	
	moreGlobals();
        processInputs();

	if (LINK) linkOutputs();
	
	driverExit(0);
}
