
/*
 * Portable Object Compiler (c) 1997,98.  All Rights Reserved.
 */

#ifndef __BLOCKEXPRESSION_H__
#define __BLOCKEXPRESSION_H__

extern id currentBlock;

@interface BlockExpression : ExpressionNode
{
	int count;
	id arguments;
	id argumentNames;
	id argumentTypes;
	id compoundStatement;
	id scope; /* collection of enclosing compounds referenced */
}

- setUpBlock;
+ new;
- free;
- blockFunctionName;
- blockDataName;
- blockDataTypeName;
- scope;
- setArguments:aNode;
- setDecls:dNode body:bNode;
- setStatements:aNode;
- setExpression:aNode;
- (int) numArgsOfBlock;
- addTempVarsTo:aStmt;
- addBlocksTo:aStmt;
- addMyBlocksTo:aStmt;
- addInlineCachesTo:aStmt;
- addScope:aScope;
- outputBlockDataTypeOn:aStream;
- packBlockDataOn:aStream;
- unpackBlockDataOn:aStream;
- processBlocks;
- pushScope;
- popScope;
- addArgumentsAsLocalsTo:compound;
- outputBlockDefsOn:aStream;
- translateOn:aStream;
@end

#endif /* __BLOCKEXPRESSION_H__ */


