
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 */

#ifndef __IDENTIFIER_H__
#define __IDENTIFIER_H__

@interface Identifier : ExpressionNode
{
	id lineTag;
	id string;
	BOOL noTypeDeclaratorMark;
}

- setUpString:aString;
- lineTag;
+ str:(STR)s;
+ string:aString;
- dontFree;
- free;

- (int) asInt;
- string;
- (BOOL) isEqual:anIdentifier;
- (unsigned) hash;
- (BOOL) isEqualSTR:(STR)s;
- (STR) str;

- doWarnLocalInstance;
+ pushScope:aScope;
+ popScope;
+ pushLocalVars:localVariables types:localTypes;
+ popLocals:localVariables;

- outputOn:stream;
- (BOOL) isSelf;
- (BOOL) isLocal;
- findScopeBlockVar;
- (BOOL) isIVar;
- (BOOL) isCVar;
+ translateSelfOn:aStream;
+ translateSelfAsIdOn:aStream;
- translateAsBlockVarOf:aScope on:stream;
- translateOn:stream asIvarOf:aClassname;
- translateOn:stream asCvarOf:aClass;
- translateFunctionHeadOn:stream;
- translateFieldOn:stream;
- translateOn:stream;
- outputWithoutTagsOn:stream;
- print;

- markNoTypeDeclarator:(BOOL)flag;
- defineBuiltinFunction;
- defineTypeName;
- defineTemplateTypeName;
+ (BOOL) inTemplate;
+ endTemplate;
- defineClassName;
- (BOOL) isBuiltinFunction;
- (BOOL) isTypeName;
- (BOOL) isClassName;
- (STR) classGlobalFun;
- (STR) classStructFun;
- (STR) metaStructFun;
- findIdentifier;

- addIvarsTo:aSet addItype:bNode to:bSet;
- addReferencedScopeToBlock:aBlock;
- (BOOL) containsStatic;
- processForMethod:aMethod;
@end

#endif /* __IDENTIFIER_H__ */

