
/*
 * Portable Object Compiler (c) 1997.  All Rights Reserved.
 */

#ifndef __NODE_H__
#define __NODE_H__

extern id setOfTypeNames;
extern id setOfClassNames;
extern int exitStatus;
char *tokenName(int token);
void fatalError(STR msg);
void warnError(STR msg);
id doAssign(id lhs,id t,id rhs);

@interface Node : Object
{
	id subnodes;
}

- setUpNode;
+ new;
- doDeepCopy;
- deepCopy;
- free;

- subnodes;
- (BOOL) isEqual:aNode;
- (BOOL) isEqualSTR:(STR)s;
- (int) asInt;
- process;

- (BOOL) isIdType;
- (BOOL) containsTypedef;
- defineTypeName;
- markNoTypeDeclarator:(BOOL)flag;

- addTempVarsTo:aStmt;
- addBlocksTo:aStmt;
- addMyBlocksTo:aStmt;
- addInlineCachesTo:aStmt;
- processBlocks;
- outputBlockDefsOn:aStream;
- addReferencedScopeToBlock:aBlock;

- findIdentifier;
- (BOOL) containsStatic;

- add:aNode;
- addIvarsTo:aSet addItype:bNode to:bSet;
- processForMethod:aMethod;

- outputOn:stream;
- outputWithoutTagsOn:stream;
- translateFieldOn:aStream;
- translateFunctionHeadOn:aStream;
- translateOn:stream;
- printOn:(IOD)f;
@end

#endif /* __NODE_H__ */

